Index: issm/trunk/src/c/classes/Elements/Tria.cpp
===================================================================
--- issm/trunk/src/c/classes/Elements/Tria.cpp	(revision 25994)
+++ issm/trunk/src/c/classes/Elements/Tria.cpp	(revision 26744)
@@ -5434,133 +6267,296 @@
 	IssmDouble* GN=NULL;
 	IssmDouble* GE=NULL;
-	IssmDouble* G_elastic_precomputed=NULL;
-	IssmDouble* G_rigid_precomputed=NULL;
-	IssmDouble* U_elastic_precomputed=NULL;
-	IssmDouble* H_elastic_precomputed=NULL;
-	IssmDouble* indices=NULL;
+	IssmDouble* G_viscoelastic_precomputed=NULL;
+	IssmDouble* G_gravi_precomputed=NULL;
+	IssmDouble* U_viscoelastic_precomputed=NULL;
+	IssmDouble* H_viscoelastic_precomputed=NULL;
 	#endif
 
-	/*elastic green function:*/
+	/*viscoelastic green function:*/
 	int index;
-	int         M;
+	int M;
+	IssmDouble doubleindex,lincoef;
 
 	/*Computational flags:*/
-	bool computerigid = false;
+	bool computeselfattraction = false;
 	bool computeelastic = false;
+	bool computerotation = false;
+	bool computeviscous = false;
 	int  horiz;
-
-	/*recover parameters: */
+	bool istime=true;
+	IssmDouble timeacc=0.;
+	IssmDouble start_time,final_time;
+	int  nt,precomputednt;
+	int grd, grdmodel;
+
+	/*Rotational:*/
+	IssmDouble* tide_love_h  = NULL;
+	IssmDouble* tide_love_k  = NULL;
+	IssmDouble* tide_love_l  = NULL;
+	IssmDouble  moi_e, moi_p, omega;
+	IssmDouble  Grotm1[3],GUrotm1[3],GNrotm1[3],GErotm1[3];
+	IssmDouble  Grotm2[3],GUrotm2[3],GNrotm2[3],GErotm2[3];
+	IssmDouble  Grotm3[3],GUrotm3[3],GNrotm3[3],GErotm3[3];
+	IssmDouble  Y21cos     , Y21sin     , Y20;
+	IssmDouble dY21cos_dlat,dY21sin_dlat,dY20_dlat;
+	IssmDouble dY21cos_dlon,dY21sin_dlon;
+	IssmDouble LoveRotRSL,LoveRotU,LoveRothoriz;
+	IssmDouble polenudge;
+	/*}}}*/
+
+	/*Recover parameters:{{{ */
 	rho_earth=FindParam(MaterialsEarthDensityEnum);
-	this->parameters->FindParam(&computerigid,SolidearthSettingsRigidEnum);
+	this->parameters->FindParam(&computeselfattraction,SolidearthSettingsSelfAttractionEnum);
 	this->parameters->FindParam(&computeelastic,SolidearthSettingsElasticEnum);
-	this->parameters->FindParam(&gsize,MeshNumberofverticesEnum);
+	this->parameters->FindParam(&computerotation,SolidearthSettingsRotationEnum);
+	this->parameters->FindParam(&computeviscous,SolidearthSettingsViscousEnum);
+	this->parameters->FindParam(&nel,MeshNumberofelementsEnum);
 	this->parameters->FindParam(&planetarea,SolidearthPlanetAreaEnum);
 	this->parameters->FindParam(&planetradius,SolidearthPlanetRadiusEnum);
+	this->parameters->FindParam(&NewtonG,ConstantsNewtonGravityEnum);
 	this->parameters->FindParam(&horiz,SolidearthSettingsHorizEnum);
-
-	/*compute area and add to inputs:*/
-	area=GetAreaSpherical();
-	this->inputs->SetDoubleInput(AreaEnum,this->lid,area);
-	this->AddInput(SealevelAreaEnum,&area,P0Enum);
-	if(!computerigid)return;
-
-	/*recover precomputed green function kernels:*/
-	DoubleVecParam* parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelriseGRigidEnum)); _assert_(parameter);
-	parameter->GetParameterValueByPointer((IssmDouble**)&G_rigid_precomputed,&M);
-
-	/*allocate indices:*/
-	indices=xNew<IssmDouble>(gsize);
-	G=xNewZeroInit<IssmDouble>(gsize);
+	this->parameters->FindParam(&grd,SolidearthSettingsGRDEnum); 
+	this->parameters->FindParam(&grdmodel,GrdModelEnum);
+
+	/*early return:*/
+	if (!grd || grdmodel!=ElasticEnum) return; //Love numbers won't be found in this case, return before loading them
+	if(!computeselfattraction)return;
+
+	if(computerotation){
+		parameters->FindParam(&tide_love_h,NULL,NULL,TidalLoveHEnum);
+		parameters->FindParam(&tide_love_k,NULL,NULL,TidalLoveKEnum);
+		parameters->FindParam(&tide_love_l,NULL,NULL,TidalLoveLEnum);
+		parameters->FindParam(&moi_e,RotationalEquatorialMoiEnum);
+		parameters->FindParam(&moi_p,RotationalPolarMoiEnum);
+		parameters->FindParam(&omega,RotationalAngularVelocityEnum);
+	}
+	/*}}}*/
+
+	/*Recover precomputed green function kernels:{{{*/
+	DoubleVecParam* parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeGSelfAttractionEnum)); _assert_(parameter);
+	parameter->GetParameterValueByPointer((IssmDouble**)&G_gravi_precomputed,&M);
 
 	if(computeelastic){
-		parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelriseGElasticEnum)); _assert_(parameter);
-		parameter->GetParameterValueByPointer((IssmDouble**)&G_elastic_precomputed,&M);
-
-		parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelriseHElasticEnum)); _assert_(parameter);
-		parameter->GetParameterValueByPointer((IssmDouble**)&H_elastic_precomputed,&M);
-
-		parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelriseUElasticEnum)); _assert_(parameter);
-		parameter->GetParameterValueByPointer((IssmDouble**)&U_elastic_precomputed,&M);
-
-		GU=xNewZeroInit<IssmDouble>(gsize);
+		parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeGViscoElasticEnum)); _assert_(parameter);
+		parameter->GetParameterValueByPointer((IssmDouble**)&G_viscoelastic_precomputed,NULL);
+
+		parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeUViscoElasticEnum)); _assert_(parameter);
+		parameter->GetParameterValueByPointer((IssmDouble**)&U_viscoelastic_precomputed,NULL);
+
 		if(horiz){
-			GN=xNewZeroInit<IssmDouble>(gsize);
-			GE=xNewZeroInit<IssmDouble>(gsize);
-		}
-	}
-
-	/* Where is the centroid of this element:*/
-
-	/*retrieve coordinates: */
+			parameter = static_cast<DoubleVecParam*>(this->parameters->FindParamObject(SealevelchangeHViscoElasticEnum)); _assert_(parameter);
+			parameter->GetParameterValueByPointer((IssmDouble**)&H_viscoelastic_precomputed,NULL);
+		}
+	}
+	/*}}}*/
+	/*Compute lat long of all vertices in the element:{{{*/
 	::GetVerticesCoordinates(&xyz_list[0][0],vertices,NUMVERTICES);
-
-	/*figure out gravity center of our element (Cartesian): */
-	x_element=(xyz_list[0][0]+xyz_list[1][0]+xyz_list[2][0])/3.0;
-	y_element=(xyz_list[0][1]+xyz_list[1][1]+xyz_list[2][1])/3.0;
-	z_element=(xyz_list[0][2]+xyz_list[1][2]+xyz_list[2][2])/3.0;
-
-	/*compute gravity center in lat,long: */
-	late= asin(z_element/planetradius);
-	longe = atan2(y_element,x_element);
-
-	constant=3/rho_earth*area/planetarea;
-
-	for(int i=0;i<gsize;i++){
-		IssmDouble alpha;
-		IssmDouble delPhi,delLambda;
-
-		/*Compute alpha angle between centroid and current vertex and index into precomputed tables: */
-		lati=latitude[i]/180*PI; longi=longitude[i]/180*PI;
-		delPhi=fabs(lati-late); delLambda=fabs(longi-longe); if (delLambda>PI)delLambda=2*PI-delLambda;
-		alpha=2.*asin(sqrt(pow(sin(delPhi/2),2)+cos(lati)*cos(late)*pow(sin(delLambda/2),2)));
-		indices[i]=alpha/PI*reCast<IssmDouble,int>(M-1);
-		index=reCast<int,IssmDouble>(indices[i]);
-
-		/*Rigid earth gravitational perturbation: */
-		G[i]+=G_rigid_precomputed[index];
-		
-		if(computeelastic){
-			G[i]+=G_elastic_precomputed[index];
-		}
-		G[i]=G[i]*constant;
-
-		/*Elastic components:*/
-		if(computeelastic){
-			GU[i] =  constant * U_elastic_precomputed[index];
+	for(int i=0;i<NUMVERTICES;i++){
+		latitude[i]= asin(xyz_list[i][2]/planetradius);
+		if((xyz_list[i][2]/planetradius)==1.0)latitude[i]=M_PI/2;
+		longitude[i]= atan2(xyz_list[i][1],xyz_list[i][0]);
+	}
+	/*}}}*/
+	/*Compute green functions:{{{ */
+	if(computeviscous){
+		this->parameters->FindParam(&istime,LoveIsTimeEnum);
+		if(!istime)_error_("Frequency love numbers not supported yet!");
+		this->parameters->FindParam(&timeacc,SolidearthSettingsTimeAccEnum);
+		this->parameters->FindParam(&start_time,TimesteppingStartTimeEnum);
+		this->parameters->FindParam(&final_time,TimesteppingFinalTimeEnum);
+		nt=reCast<int,IssmDouble>((final_time-start_time)/timeacc)+1;
+	}
+	else{
+		nt=1; //in elastic, or if we run only selfattraction, we need only one step
+	}
+
+	constant=3/rho_earth/planetarea;
+
+	G=xNewZeroInit<IssmDouble>(3*nel*nt);
+	if(computeelastic){
+		GU=xNewZeroInit<IssmDouble>(3*nel*nt);
+		if(horiz){
+			GN=xNewZeroInit<IssmDouble>(3*nel*nt);
+			GE=xNewZeroInit<IssmDouble>(3*nel*nt);
+		}
+	}
+
+	for(int e=0;e<nel;e++){
+		ratioe=constant*areae[e];
+		for (int i=0;i<3;i++){
+			IssmDouble alpha;
+			IssmDouble delPhi,delLambda;
+			/*recover info for this element and vertex:*/
+			IssmDouble late= asin(zze[e]/sqrt( pow(xxe[e],2.0)+ pow(yye[e],2.0)+ pow(zze[e],2.0)));
+			IssmDouble longe= atan2(yye[e],xxe[e]);
+
+			lati=latitude[i];
+			longi=longitude[i];
+
+			/*Compute alpha angle between centroid and current vertex and index into precomputed tables: */
+			delPhi=fabs(lati-late); delLambda=fabs(longi-longe); if (delLambda>M_PI)delLambda=2*M_PI-delLambda;
+			alpha=2.*asin(sqrt(pow(sin(delPhi/2),2)+cos(lati)*cos(late)*pow(sin(delLambda/2),2)));
+			doubleindex=alpha/M_PI*reCast<IssmDouble,int>(M-1); //maps 0<alpha<PI on [0:M-1]
+			index=reCast<int,IssmDouble>(doubleindex); //truncates doubleindex to integer part
+			_assert_(index>=0 && index<M);
+
+			lincoef=doubleindex-index; //where between index and index+1 is alpha
+			if (index==M-1){ //avoids out of bound case
+				index-=1;
+				lincoef=1;
+			}
+
 			if(horiz){
 				/*Compute azimuths, both north and east components: */
-				x = xx[i]; y = yy[i]; z = zz[i];
-				if(latitude[i]==90){
+				x = xyz_list[i][0]; y = xyz_list[i][1]; z = xyz_list[i][2];
+				if(lati==M_PI/2){
 					x=1e-12; y=1e-12;
 				}
-				if(latitude[i]==-90){
+				if(lati==-M_PI/2){
 					x=1e-12; y=1e-12;
 				}
-				dx = x_element-x; dy = y_element-y; dz = z_element-z;
+				dx = xxe[e]-x; dy = yye[e]-y; dz = zze[e]-z;
 				N_azim = (-z*x*dx-z*y*dy+(pow(x,2)+pow(y,2))*dz) /pow((pow(x,2)+pow(y,2))*(pow(x,2)+pow(y,2)+pow(z,2))*(pow(dx,2)+pow(dy,2)+pow(dz,2)),0.5);
 				E_azim = (-y*dx+x*dy) /pow((pow(x,2)+pow(y,2))*(pow(dx,2)+pow(dy,2)+pow(dz,2)),0.5);
-
-				GN[i] = constant*H_elastic_precomputed[index]*N_azim;
-				GE[i] = constant*H_elastic_precomputed[index]*E_azim;
-			}
-		}
-	}
+			}
+
+			for(int t=0;t<nt;t++){
+				int timeindex=i*nel*nt+e*nt+t; 
+
+				/*Rigid earth gravitational perturbation: */
+				G[timeindex]+=G_gravi_precomputed[index+0]*(1.-lincoef) 
+					     +G_gravi_precomputed[index+1]*lincoef; //linear interpolation
+
+				/*Find a way to interpolate precomputed Gkernels to our solution time stepping:*/
+				if(computeelastic){
+					G[timeindex]+=G_viscoelastic_precomputed[(index+0)*nt+t]*(1.-lincoef)
+						     +G_viscoelastic_precomputed[(index+1)*nt+t]*lincoef; //linear interpolation
+				}
+				G[timeindex]=G[timeindex]*ratioe;
+
+				/*Elastic components:*/
+				if(computeelastic){
+					GU[timeindex] =  ratioe *(U_viscoelastic_precomputed[(index+0)*nt+t]*(1.-lincoef)
+								 +U_viscoelastic_precomputed[(index+1)*nt+t]*lincoef);
+					if(horiz){
+						GN[timeindex] = N_azim*ratioe *(H_viscoelastic_precomputed[(index+0)*nt+t]*(1.-lincoef)
+								 	       +H_viscoelastic_precomputed[(index+1)*nt+t]*lincoef);
+						GE[timeindex] = E_azim*ratioe *(H_viscoelastic_precomputed[(index+0)*nt+t]*(1.-lincoef)
+								 	       +H_viscoelastic_precomputed[(index+1)*nt+t]*lincoef);
+					}
+				}
+			} //for(int t=0;t<nt;t++)
+		} //for (int i=0;i<3;i++)
+	} //for(int e=0;e<nel;e++)
 
 	/*Add in inputs:*/
-	this->inputs->SetArrayInput(SealevelriseIndicesEnum,this->lid,indices,gsize);
-	this->inputs->SetArrayInput(SealevelriseGEnum,this->lid,G,gsize);
+	this->inputs->SetArrayInput(SealevelchangeGEnum,this->lid,G,nel*3*nt);
 	if(computeelastic){
-		this->inputs->SetArrayInput(SealevelriseGUEnum,this->lid,GU,gsize);
+		this->inputs->SetArrayInput(SealevelchangeGUEnum,this->lid,GU,nel*3*nt);
 		if(horiz){
-			this->inputs->SetArrayInput(SealevelriseGNEnum,this->lid,GN,gsize);
-			this->inputs->SetArrayInput(SealevelriseGEEnum,this->lid,GE,gsize);
-		}
-	}
-	this->inputs->SetDoubleInput(AreaEnum,this->lid,area); 
-	this->AddInput(SealevelAreaEnum,&area,P0Enum);
-
-	/*Free allocations:*/
+			this->inputs->SetArrayInput(SealevelchangeGNEnum,this->lid,GN,nel*3*nt);
+			this->inputs->SetArrayInput(SealevelchangeGEEnum,this->lid,GE,nel*3*nt);
+		}
+	}
+	/*}}}*/
+	/*Compute rotation kernel:{{{*/
+	if(computerotation){
+
+		/*What is the gravity at planet's surface: */
+		g=4.0/3.0*M_PI*rho_earth*NewtonG*planetradius;
+
+		//Amplitude of the rotational feedback
+		LoveRotRSL=((1.0+tide_love_k[2]-tide_love_h[2])/g)*pow(omega*planetradius,2.0);
+		LoveRotU=(tide_love_h[2]/g)*pow(omega*planetradius,2.0);
+		LoveRothoriz=(tide_love_l[2]/g)*pow(omega*planetradius,2.0);
+
+		for(int i=0;i<3;i++){
+
+			//Avoid singularity of the poles
+			if (latitude[i]==M_PI/2.){
+				//North pole: nudge south
+				polenudge=-1.e-12;
+			}
+			else if (latitude[i]==-M_PI/2.){
+				//South pole: nudge north
+				polenudge=1.e-12;
+			}
+			else {
+				polenudge=0.0;
+			}
+
+			lati=latitude[i]+polenudge;
+			longi=longitude[i];
+
+			//Spherical harmonic functions of degree 2
+			Y21cos= -0.5*sin(2.*lati)*cos(longi);
+			Y21sin= -0.5*sin(2.*lati)*sin(longi);
+			Y20   = -(1.0/6.0 - 0.5*cos(2.0*lati));
+
+			Grotm1[i]= LoveRotRSL*Y21cos;
+			Grotm2[i]= LoveRotRSL*Y21sin;
+			Grotm3[i]= LoveRotRSL*Y20;
+
+			if (computeelastic){
+				GUrotm1[i]= LoveRotU*Y21cos;
+				GUrotm2[i]= LoveRotU*Y21sin;
+				GUrotm3[i]= LoveRotU*Y20;
+				if (horiz){
+				//bed_N = Love_l * d(Y)/dlat ;
+				dY21cos_dlat=-cos(2.*lati)*cos(longi);
+				dY21sin_dlat=-cos(2.*lati)*sin(longi);
+				dY20_dlat=   -sin(2.*lati);
+				GNrotm1[i]= LoveRothoriz*dY21cos_dlat;
+				GNrotm2[i]= LoveRothoriz*dY21sin_dlat;
+				GNrotm3[i]= LoveRothoriz*dY20_dlat;
+
+				//bed_E = Love_l * 1/cos(lat) * d(Y)/dlon ;
+				dY21cos_dlon=-Y21sin/cos(lati);
+				dY21sin_dlon=Y21cos/cos(lati);
+				//dY20_dlon=0.;
+
+				GErotm1[i]= LoveRothoriz*dY21cos_dlon;
+				GErotm2[i]= LoveRothoriz*dY21sin_dlon;
+				GErotm3[i]= 0.0;
+				}
+			}
+		}
+		this->AddInput(SealevelGrotm1Enum,&Grotm1[0],P1Enum);
+		this->AddInput(SealevelGrotm2Enum,&Grotm2[0],P1Enum);
+		this->AddInput(SealevelGrotm3Enum,&Grotm3[0],P1Enum);
+		if (computeelastic){
+			this->AddInput(SealevelGUrotm1Enum,&GUrotm1[0],P1Enum);
+			this->AddInput(SealevelGUrotm2Enum,&GUrotm2[0],P1Enum);
+			this->AddInput(SealevelGUrotm3Enum,&GUrotm3[0],P1Enum);
+			if(horiz){
+				this->AddInput(SealevelGNrotm1Enum,&GNrotm1[0],P1Enum);
+				this->AddInput(SealevelGNrotm2Enum,&GNrotm2[0],P1Enum);
+				this->AddInput(SealevelGNrotm3Enum,&GNrotm3[0],P1Enum);
+				this->AddInput(SealevelGErotm1Enum,&GErotm1[0],P1Enum);
+				this->AddInput(SealevelGErotm2Enum,&GErotm2[0],P1Enum);
+				this->AddInput(SealevelGErotm3Enum,&GErotm3[0],P1Enum);
+			}
+		}
+	}
+	/*}}}*/
+	/*Initialize viscous stacks: {{{*/
+	if(computeviscous){
+		viscousRSL=xNewZeroInit<IssmDouble>(3*nt);
+		viscousU=xNewZeroInit<IssmDouble>(3*nt);
+
+		this->inputs->SetArrayInput(SealevelchangeViscousRSLEnum,this->lid,viscousRSL,3*nt);
+		this->inputs->SetArrayInput(SealevelchangeViscousUEnum,this->lid,viscousU,3*nt);
+		this->parameters->SetParam(0,SealevelchangeViscousIndexEnum);
+		if(horiz){
+			viscousN=xNewZeroInit<IssmDouble>(3*nt);
+			viscousE=xNewZeroInit<IssmDouble>(3*nt);
+			this->inputs->SetArrayInput(SealevelchangeViscousNEnum,this->lid,viscousRSL,3*nt);
+			this->inputs->SetArrayInput(SealevelchangeViscousEEnum,this->lid,viscousU,3*nt);
+		}
+	}
+	/*}}}*/
+
+	/*Free allocations:{{{*/
 	#ifdef _HAVE_RESTRICT_
-	delete indices;
 	delete G;
 	if(computeelastic){
@@ -5572,5 +6568,4 @@
 	}
 	#else
-	xDelete(indices);
 	xDelete(G);
 	if(computeelastic){
